﻿Imports C1.Win.C1FlexGrid
Imports System.Data.OleDb

Public Class Form1

    Dim clickeddata As String = String.Empty

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        ' get data
        Dim da = New OleDbDataAdapter(My.Resources.SqlStatement, GetConnectionString())
        Dim dt = New DataTable("NorthWind Sales Data")
        da.Fill(dt)

        ' assign data to C1OlapPage control
        _c1OlapPage.DataSource = dt

        _c1OlapPage.OlapGrid.ShowDetailOnRightClick = False

        'Get Clicked Data

        AddHandler _c1OlapPage.OlapGrid.BeforeMouseDown, AddressOf _c1OlapPage_OlapGrid_BeforeMouseDown

    End Sub

    'handle the click event of the 'Copy' menu item on the contextmenustrip
    Private Sub copyMenuItem1_Click(sender As Object, e As EventArgs) Handles copyMenuItem1.Click
        Try
            'store the captured data from 'clickeddata' in a clipboard object
            _c1OlapPage.OlapGrid.ClipboardCopyMode = ClipboardCopyModeEnum.DataOnly
            Clipboard.SetData(System.Windows.Forms.DataFormats.StringFormat, clickeddata)

        Catch ex As Exception
            'display the error message
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    ' get standard nwind mdb connection string
    Private Shared Function GetConnectionString() As String
        Dim path As String = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + "\ComponentOne Samples\Common"
        Dim conn As String = "provider=microsoft.jet.oledb.4.0;data source={0}\c1nwind.mdb;"
        Return String.Format(conn, path)
    End Function

    'Get Clicked Data on the BeforeMouseDown event of the grid
    Private Sub _c1OlapPage_OlapGrid_BeforeMouseDown(sender As System.Object, _e As C1.Win.C1FlexGrid.BeforeMouseDownEventArgs)
        'check if the cell is right clicked 
        If _e.Button = MouseButtons.Right AndAlso _e.Clicks > 0 Then

            'store the HitTest information in a variable 'hti'
            Dim hti As C1.Win.C1FlexGrid.HitTestInfo = _c1OlapPage.OlapGrid.HitTest(_e.X, _e.Y)

            'make sure we are working with the row header
            If hti.Type = HitTestTypeEnum.RowHeader Then
                'assign a contextmenustrip to the olapgrid
                _c1OlapPage.OlapGrid.ContextMenuStrip = contextMenuStrip1
                'get the row header text in some variable 'clickeddata' 
                clickeddata = _c1OlapPage.OlapGrid.GetData(_c1OlapPage.OlapGrid.MouseRow, _c1OlapPage.OlapGrid.MouseCol).ToString()
            End If

            ' make sure we are working with a cell
            If hti.Type = C1.Win.C1FlexGrid.HitTestTypeEnum.Cell Then
                ' get data using OlapEngine
                Dim data = _c1OlapPage.OlapEngine.GetDetail(TryCast(_c1OlapPage.OlapGrid.Rows(hti.Row).DataSource, DataRowView).Row, _c1OlapPage.OlapEngine.OlapTable.Columns(0).ColumnName)
                Dim f As New Form()
                f.Size = New Size(400, 250)
                f.StartPosition = FormStartPosition.CenterParent
                f.Text = "Customized Detail View : " + data.Count.ToString() + " records"
                Dim flex As New C1.Win.C1FlexGrid.C1FlexGrid()
                flex.Dock = DockStyle.Fill
                flex.DataSource = data
                f.Controls.Add(flex)
                'display the custom dialog form
                f.ShowDialog()
            End If

            If hti.Type = HitTestTypeEnum.ColumnHeader Then
                _c1OlapPage.OlapGrid.ContextMenuStrip = Nothing
            End If

        End If
    End Sub
End Class
